unit MainUnit; 

{$mode objfpc}{$H+}

{ ------------------------------------------------------------------------------

       latest changes:  2021-02-09 - compiled with Lazarus 2.0.10

------------------------------------------------------------------------------ }

{
  This is the LCL version of  FPC example program  TestPAbasic.pas
  from the HuMuS project.

  In August 2010 I switched to the PORTAUDIO.PAS from ULTRASTAR project
  because this source file is well documented and all needed code
  resides in just one file which makes life easier .. ;-)

  latest changes:  2019-04-16 - checked with Lazarus 2.0

  ---------------------------------------------------------------

  from PortAudio bindings for FPC by the HuMuS team - Basic test program
  Latest version available at: http://sourceforge.net/apps/trac/humus/

  Copyright (c) 2009-2010 Roland Schaefer

  PortAudio Portable Real-Time Audio Library
  Latest version available at: http://www.portaudio.com

  Permission is hereby granted, free of charge, to any person obtaining
  a copy of this software and associated documentation files
  (the "Software"), to deal in the Software without restriction,
  including without limitation the rights to use, copy, modify, merge,
  publish, distribute, sublicense, and/or sell copies of the Software,
  and to permit persons to whom the Software is furnished to do so,
  subject to the following conditions:

  The above copyright notice and this permission notice shall be
  included in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR
  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  The text above constitutes the entire PortAudio license; however,
  the PortAudio community also makes the following non-binding requests:

  Any person wishing to distribute modifications to the Software is
  requested to send the modifications to the original developer so that
  they can be incorporated into the canonical version. It is also
  requested that these non-binding requests be included along with the
  license above.
}

interface

uses
  Interfaces,
  Forms, Classes, SysUtils, FileUtil, LResources, Controls, StdCtrls, ExtCtrls,
  Graphics, Dialogs,CTypes,
  portaudio; { using PortAudio here statically links the portaudio DLL ! }


type
  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    HaCount: CInt32;
    HaInfo: PPaHostApiInfo;
  end;

var
  Form1: TForm1; 


implementation

{$R *.lfm}

{ ***** TForm1 *************************************************************** }
procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Err : CInt32;
  i   : integer;
begin
  Button1.Enabled:= FALSE;
  Button2.Enabled:= FALSE;

  Memo1.Clear;
  // the only informations we can get without Pa_Initialize() :
  Memo1.Append( 'PA version text:' +#9  +Pa_GetVersionText);
  Memo1.Append( 'PA version int:'  +#9  +IntToStr( Pa_GetVersion));

  // init PA
  Err:= Pa_Initialize;
  if Err = 0 then
    begin
      Memo1.Append( 'init PortAudio DLL: '  +#9  +Pa_GetErrorText( CInt32( Pa_Initialize)));
      Memo1.Append( ''); //empty line
      Memo1.Append( ''); //empty line

      // print some system information provided by PA
      HaCount:= Pa_GetHostApiCount;
      Memo1.Append( 'Host API count (OK if positive): ' +#9 +IntToStr( HaCount));
      Memo1.Append( ''); //empty line

      for i:= 0 to (HaCount -1) do
        begin
          HaInfo:= Pa_GetHostApiInfo ( i );
          Memo1.Append( '  Found host API ' +IntToStr(i) +' which is ' +#9
                        +HaInfo^.name +' (devices: '
                        +IntToStr( HaInfo^.deviceCount) +')');
        end;

      Memo1.Append( ''); //empty line
      Memo1.Append( '  Default host API: ' +#9#9 +IntToStr( Pa_GetDefaultHostApi));
      Memo1.Append( '  Default output device: ' +#9 +IntToStr( Pa_GetDefaultOutputDevice));

      { end all PA activity  - Pa_Terminate() is a little bit hidden in this example : }
      Memo1.Append( ''); //empty line
      Memo1.Append( 'terminate PortAudio DLL: ' +#9
                    +Pa_GetErrorText( CInt32( Pa_Terminate() )));
    end;

  Button1.Enabled:= TRUE;
  Button2.Enabled:= TRUE;
end;


end.

